<?php
define('ABSPATH',dirname(dirname(__FILE__)));
define('DEBUG',0);
define('PHP_TAB',"\t");
date_default_timezone_set('Europe/Moscow');

    //PHP_VERSION    
	/*if ( !function_exists('version_compare') || version_compare( phpversion(), '7', '<=' ) )
		{
			
		}
	else
		{
			
		}
		
    */

include_once(ABSPATH.'/config.php');

if (!defined('DB_PORT')) {
    define('DB_PORT',3306);
}

class mk7877 {
    static private $system=false;
    private $model=false;
    private $config=false;
    private $api_key='1234567890';
    private $params=array();
    
    static public function init() {
        if (self::$system) return;
        
        self::$system=new static();
        self::$system->execute();
    }
    
    public function __construct() {
        spl_autoload_register(array($this,'loader'));
        header('Content-Type: text/xml; charset=windows-1251');
        $this->model=new mysql();
    }
    
    private function loader($name) {
        $name=preg_replace('{[^a-z0-9\-_]}is','',$name);
        $filename=ABSPATH.'/mk/classes/'.$name.'.php';
        
        if (file_exists($filename)) include_once($filename);
    }    
    
    public function get($name) {
        return isset($this->params[$name]) ? $this->params[$name] : false;
    }
    
    private function initParams() {
        $this->params=include_once(ABSPATH.'/mk/config.php');        
        $this->params['act']=isset($_GET['act']) ? $_GET['act'] : false;
        $this->params['api_key']=isset($_GET['api_key']) ? $_GET['api_key'] : false;
        $this->params['g_index']=isset($_GET['g_index']) ? $_GET['g_index'] : false;
        $this->params['get_null']=isset($_GET['get_null']) ? $_GET['get_null'] : false;
        $this->params['user_id']=isset($_GET['user_id']) ? $_GET['user_id'] : false;
        $this->params['discount']=isset($_GET['discount']) ? $_GET['discount'] : false;
        $this->params['store_id']=isset($_GET['store_id']) ? $_GET['store_id'] : false;        
        $this->params['id2']=isset($_GET['id2']) ? $_GET['id2'] : false;
    }
    
    private function log() {
        $log=@date('Y:m:d H:i:s');
        $log.=' ACT: '.$this->get('act').PHP_EOL;
        
        if (count($_GET)) {
            $log.='GET: '.PHP_EOL;
            foreach($_GET as $k=>$v) {
                $log.=$k.'='.$v.'&';
            }
            $log=trim($log,'&');
            $log.=PHP_EOL;
        }
        
        if (count($_POST)) {
            $log.='POST: '.PHP_EOL;
            foreach($_POST as $k=>$v) {
                $log.=$k.'='.$v.'&';
            }
            $log=trim($log,'&');
            $log.=PHP_EOL;            
        }
        
        $log.=PHP_EOL;
        
        $fp=fopen(ABSPATH.'/mk/log.txt','a');
        if ($fp) {
            fwrite($fp,$log);
            fclose($fp);
        }
    }
    
    private function safe_string($data) {
        $data=str_replace("&quot;", "`", $data);
        $data=str_replace("&", "/", $data);
        $data=str_replace("'", "`", $data);
        
        $data=str_replace("<span style=`color: rgb(255, 0, 0);`>[ ]</span>", "", $data);
        $data=str_replace('"', "`", $data);        
        return $data;
    }
    
    private function xml($data,$wrap) {
        $data='<?xml version="1.0" encoding="windows-1251"?>'.PHP_EOL.'<'.$wrap.'>'.PHP_EOL.$data.'</'.$wrap.'>'.PHP_EOL;
        return $data;
    }
    
    private function convert($data) {
        $data=(string)$data;
        $data=mb_convert_encoding($data,'windows-1251','UTF-8');
        return $data;
    }
    
    private function format($data,$type) {
        $count=$this->get('format_'.$type);
        $count=is_numeric($count) ? intval($count) : 0;
        if ($count) {
            $data=round($data,2);
        } else {
             $data=round($data,2);
        }
        return $data;
    }
    
    private function execute() {
        $this->initParams();
        $act='action_'.$this->get('act');
        $api_key=$this->get('api_key');
        if (!DEBUG) {
            if ($api_key!=$this->api_key || !method_exists($this,$act)) {
                echo 'error';
                return;
            }
        }
        
        if (DEBUG) {
            $this->log();
        }
        
        echo $this->$act();                    
    }
    
    private function action_connect() {
        $result='ok';
        return $result;
    }

    private function action_cron() {
        $pay_code=$this->get('pay_code');
        $order_status_id=$this->get('yandex_order_status_id');
        $one=$this->model->one("SELECT * FROM `oc_order` AS o WHERE (o.payment_code='$pay_code' AND o.order_status_id='$order_status_id' AND o.yd!=1) ORDER BY o.order_id ASC LIMIT 0,1");	
        if (!isset($one['payment_code'])) {
        	
        	//mail(($this->get('email')), 'CRON', '   _!');
        	$result='Send email 0';
        	return $result;
        
        } else {
			
		mail(($this->get('email')), 'CRON', '    !');
        $result='Send email 1';
        return $result;	
		}
    }
   
   
    
    private function action_stores() {
        $result='';
        $res=$this->model->query('SELECT * FROM `oc_setting` AS s WHERE s.key=\'config_name\' ORDER BY s.store_id ASC');
        if ($res) {
            while($row=$this->model->fetch($res)) {
                $result.=PHP_TAB.'<store id="'.$row['store_id'].'">'.$row['value'].'</store>'.PHP_EOL;
            }
        }
        $result=$this->xml($result,'stores');
        return $result;
    }
    
    private function action_catalog() {//and d.language_id=\'1\'  //    
        $result='';
        $res=$this->model->query('SELECT c.category_id,c.parent_id,d.name FROM `oc_category_to_store` AS s 
                            INNER JOIN `oc_category` AS c ON (c.category_id=s.category_id)
                            INNER JOIN `oc_category_description` AS d ON (d.category_id=s.category_id)
                            '.($this->get('store_id') ? 'WHERE s.store_id='.$this->get('store_id') : '').' 
                            ORDER BY s.store_id, c.category_id ASC');
        if ($res) {
            while($row=$this->model->fetch($res)) {
                $row['name']=base64_encode($row['name']);
                $result.=PHP_TAB.'<category id="'.$row['category_id'].'" parentId="'.$row['parent_id'].'">'.$row['name'].'</category>'.PHP_EOL;
            }
        }
        $result=$this->xml($result,'categories');
        return $result;
    }
    

    //  
    private function action_goods() {
        $result='';
        $sql_add='';
        if ($this->get('get_null')=='0'){
		$sql_add='AND p.quantity>0';	
		}
        
        $res=$this->model->query('SELECT p.*,d.name,s.price as special_price,s.date_start,s.date_end, c.category_id FROM `oc_product_to_category` AS c 
                            INNER JOIN `oc_product` AS p ON (p.product_id=c.product_id)
                            INNER JOIN `oc_product_description` AS d ON (d.product_id=c.product_id)
                            LEFT JOIN `oc_product_special` AS s ON (s.product_id=c.product_id)
                            WHERE c.category_id='.$this->get('g_index').($this->get('get_null')==1 ? '' : ' AND p.quantity>0').' '.$sql_add.'
                            ORDER BY d.name ASC');        
                          
        if ($res) {
            while($row=$this->model->fetch($res)) {
                $row['sale']=0;
                
                if ($row['special_price']) {
                    $dateline=time();
                    $start=strtotime($row['date_start']);
                    $end=strtotime($row['date_end']);
                    if ($start<$dateline && $end>$dateline) {
                        $row['price']=$row['special_price'];
                        $row['sale']=1;
                    }
                }
                
                $row['model']=$this->safe_string($row['name']);                
                $row['price']=$this->format($row['price'],'goods');                
                $result.='<good cat_id ="'.$row['category_id'].'" id="'.$row['product_id'].'" goods_sale="'.$row['sale'].'" goods_sn="'.$row['sku'].'" barcode="'.$row['ean'].'" goods_number="'.$row['quantity'].'" shop_price="'.$row['price'].'">'.$row['model'].'</good>'.PHP_EOL;
            }
        }
        $result=$this->xml($result,'goods');
        return $result;
    }
    
    private function action_goods_pack() {
        $result='';
        $result.=PHP_TAB.'<good id="1" goods_sale="" goods_sn="" barcode="" goods_number="" shop_price="">   Opencart.</good>'.PHP_EOL;
        $result=$this->xml($result,'goods');
        return $result;
    }
    
    private function action_nabor() {
        $result='';
        $name='   Opencart!';
        $result.=PHP_TAB.'<good id="1" package_price="0">'.base64_encode($name).'"</good>'.PHP_EOL;        
        $result=$this->xml($result,'goods');
        return $result;
    }
    
    private function action_goods_sql() {
        $result='<goods>'.PHP_EOL;
        $result.='</goods>'.PHP_EOL;        
    }
    
    private function action_goods2() {
        $result='';
        $sql_add='';
        $id=$this->get('g_index');
        $id=intval($id);
        if (!$id) return;
        //$res=$this->model->query("SELECT p.*,d.name FROM oc_product_to_category AS c 
        //                    INNER JOIN oc_product AS p ON (p.product_id=c.product_id)
        //                    INNER JOIN oc_product_description AS d ON (d.product_id=c.product_id)
        //                    WHERE c.category_id=$id
        //                    ORDER BY p.product_id ASC");
         $res=$this->model->query('SELECT p.*,d.name FROM `oc_product_to_category` AS c 
                            INNER JOIN `oc_product` AS p ON (p.product_id=c.product_id)
                            INNER JOIN `oc_product_description` AS d ON (d.product_id=c.product_id)
                            WHERE c.category_id='.$this->get('g_index').($this->get('get_null')==1 ? '' : ' AND p.quantity>0').' '.$sql_add.'
                            ORDER BY d.name ASC');
        if ($res) {
            while($row=$this->model->fetch($res)) {
                $row['name']=$this->safe_string($row['name']);
                $row['price']=$this->format($row['price'],'goods2');
                $result.='<good id="'.$row['product_id'].'" goods_sale="0" goods_sn="'.$row['sku'].'" goods_number="'.$row['quantity'].'" shop_price="'.$row['price'].'" goods_barcode="'.$row['ean'].'">'.$row['name'].'</good>';
            }
        }
        $result=$this->xml($result,'goods');
        return $result;
    }
    
    private function action_goods2_64() {
        $result='';
        $sql_add='';
        $id=$this->get('g_index');
        $id=intval($id);
        if (!$id) return;
        //$res=$this->model->query("SELECT p.*,d.name FROM oc_product_to_category AS c 
        //                    INNER JOIN oc_product AS p ON (p.product_id=c.product_id)
        //                    INNER JOIN oc_product_description AS d ON (d.product_id=c.product_id)
        //                    WHERE c.category_id=$id
        //                    ORDER BY p.product_id ASC");
         $res=$this->model->query('SELECT p.*,d.name FROM `oc_product_to_category` AS c 
                            INNER JOIN `oc_product` AS p ON (p.product_id=c.product_id)
                            INNER JOIN `oc_product`_description AS d ON (d.product_id=c.product_id)
                            WHERE c.category_id='.$this->get('g_index').($this->get('get_null')==1 ? '' : ' AND p.quantity>0').' '.$sql_add.'
                            ORDER BY d.name ASC');
        if ($res) {
            while($row=$this->model->fetch($res)) {
                $row['name']=$this->safe_string($row['name']);
                $row['price']=$this->format($row['price'],'goods2');
                $result.='<good id="'.$row['product_id'].'" goods_sale="0" goods_sn="'.$row['sku'].'" goods_number="'.$row['quantity'].'" shop_price="'.$row['price'].'" goods_barcode="'.$row['ean'].'">'.$row['name'].'</good>';
            }
        }
        $result=$this->xml($result,'goods');
        return $result;
    }
    
    
    private function action_goods3() {
        $result='';
        $id=$this->get('g_index');
        $id=trim($id);
        if (!$id) return;
        $res=$this->model->query("SELECT p.*,d.name FROM `oc_product` AS p
                            INNER JOIN `oc_product_description` AS d ON (d.product_id=p.product_id)
                            WHERE p.ean='$id'
                            ORDER BY p.product_id ASC");
        if ($res) {
            while($row=$this->model->fetch($res)) {
                $row['name']=$this->safe_string($row['name']);
                $row['price']=$this->format($row['price'],'goods2');
                $result.='<good id="'.$row['product_id'].'" goods_sale="0" goods_sn="'.$row['sku'].'" goods_number="'.$row['quantity'].'" shop_price="'.$row['price'].'" goods_barcode="'.$row['ean'].'">'.$row['name'].'</good>';
            }
        }
        $result=$this->xml($result,'goods');
        return $result;        
    }
    
    
        private function action_goods3_64() {
        $result='';
        $id=$this->get('g_index');
        $id=base64_decode($id);
        $id=trim($id);
        if (!$id) return;
        $res=$this->model->query("SELECT p.*,d.name FROM `oc_product` AS p
                            INNER JOIN `oc_product_description` AS d ON (d.product_id=p.product_id)
                            WHERE p.ean='$id'
                            ORDER BY p.product_id ASC");
        if ($res) {
            while($row=$this->model->fetch($res)) {
                $row['name']=$this->safe_string($row['name']);
                $row['price']=$this->format($row['price'],'goods2');
                $result.='<good id="'.$row['product_id'].'" goods_sale="0" goods_sn="'.$row['sku'].'" goods_number="'.$row['quantity'].'" shop_price="'.$row['price'].'" goods_barcode="'.$row['ean'].'">'.$row['name'].'</good>';
            }
        }
        $result=$this->xml($result,'goods');
        return $result;        
    }
    
    
    private function action_finduser() {
        $result='';
        $search=$this->get('g_index');
        $search=base64_decode($search);
        $search=mb_convert_encoding($search,'cp1251','utf8');
        $search=$this->model->escape($search);
        $res=$this->model->query('SELECT * FROM `oc_customer` AS c 
                            WHERE '.($this->get('store_id') ? 'c.store_id='.$this->get('store_id').' AND ': '').'(c.firstname LIKE \'%'.$search.'%\' OR c.lastname LIKE \'%'.$search.'%\' OR c.email LIKE \'%'.$search.'%\' OR c.telephone LIKE \'%'.$search.'%\')
                            ORDER BY c.customer_id ASC
                            LIMIT 0,20');
        if ($res) {
            while($row=$this->model->fetch($res)) {
                $row['name']=$row['firstname'].' '.$row['lastname'];
                $result.=PHP_TAB.'<user id="'.$row['customer_id'].'" barcode="'.$row['barcode'].'" find_user_email="'.$row['email'].'" find_user_id="'.$row['customer_id'].'">'.$row['name'].'</user>'.PHP_EOL;
            }
        }
        $result=$this->xml($result,'users');
        return $result;
    }
    
//        where  o.payment_code='cod' and  o.order_status_id=2 and yd!=1 
        private function action_findzakaz_android() {
        $result='';
        /*
        $res=$this->model->query('SELECT * FROM `oc_order` AS o 
                            '.($this->get('store_id') ? 'WHERE s.store_id='.$this->get('store_id') : " where  o.payment_code='cod' and  o.order_status_id=2 and (yd!=3 and yd!=1 and yd!=2)")." 
                              ORDER BY o.order_id DESC
                            LIMIT 0,20");
                            
         */
         //      
         $res=$this->model->query('SELECT * FROM `oc_order` AS o 
                            '.($this->get('store_id') ? 'WHERE s.store_id='.$this->get('store_id') : " where  yd!=3 and yd!=1 and yd!=2")." 
                              ORDER BY o.order_id DESC
                            LIMIT 0,20");
         
                            
                            
                            
        if ($res) {
            while($row=$this->model->fetch($res)) {
                $row['name']=$row['firstname'].' '.$row['lastname'];
                $row['total']=$this->format($row['total'],'findzakaz');
                $row['shipping_fee']=0;
                $shipping=$this->getOrderShipping($row['order_id']);
                if ($shipping) {
                    $row['shipping_fee']=$shipping['cost'];
                }
                $row['discount']=0;
                $discount=$this->getOrderDiscount($row['order_id']);
                if ($discount) {
                    $row['discount']=$discount;
                }
                
                if (!$row['discount']) {
                    $discount=new discount($this->model,$this->get('order_status_id_update'));
                    $discount=$discount->getDiscount($row['customer_id']);
                    $discount=100-$discount;
                    if ($discount) {
                        $total=$row['total']-$row['shipping_fee'];
                        $total+=($total/100)*$discount;
                        $discount=($total/100)*$discount;
                        $discount=$this->format($discount,'findzakaz');
                    }                    
                    $row['discount']=$discount;
                }
                
                $result.=PHP_TAB.'<user id="'.$row['order_id'].'" find_date="'.$row['date_added'].'" find_zakaz_id="'.$row['order_id'].'" find_zakaz_amount="'.$row['total'].'" find_shipping_fee="'.$row['shipping_fee'].'" find_user_name="'.$row['name'].'" find_surplus="0" find_discount="'.$row['discount'].'">'.$row['order_id'].'</user>'.PHP_EOL;
            }
        }
        $result=$this->xml($result,'users');
        return $result;
    }
    
//      
    private function action_set_pay_money() {
        $id=$this->get('g_index');
        $id=intval($id);
        if (!$id) return;
        $id2=$this->get('id2');
        $this->model->query("UPDATE `oc_order` SET `yd`='".$id2."' WHERE `order_id`='$id'");
        $result='ok';
        return $result;
    }    
    

//   01.05.18
    private function action_vozvrat() {
        $id=$this->get('g_index');
        $id=intval($id);
        if (!$id) return;
        
        $this->model->query("UPDATE `oc_order` SET `order_status_id`='{$this->get('order_return_id')}' WHERE `order_id`='".$id."'");
        $result='ok';
        return $result;
    } 
    
    
    //          
    private function action_findzakaz() {
        $result='';
        $res=$this->model->query('SELECT * FROM `oc_order` AS o 
                            '.($this->get('store_id') ? 'WHERE s.store_id='.$this->get('store_id') : '').'
                            ORDER BY o.order_id DESC
                            LIMIT 0,200');
        if ($res) {
            while($row=$this->model->fetch($res)) {
                $row['name']=$row['firstname'].' '.$row['lastname'];
                $row['total']=$this->format($row['total'],'findzakaz');
                $row['shipping_fee']=0;
                $shipping=$this->getOrderShipping($row['order_id']);
                if ($shipping) {
                    $row['shipping_fee']=$shipping['cost'];
                    $row['total']=$row['total']-$shipping['cost'];
                }
                $row['discount']=0;
                //$discount=$this->getOrderDiscount($row['order_id'],2);
                //if ($discount) {
                	
                    $row['discount']=($this->getOrderTotal($row['order_id']))-$this->format($row['total'],'findzakaz');//     
                //}
                $row['discount2']=$this->getUserPointsByOrder($row['order_id']);
                
                $result.=PHP_TAB.'<user id="'.$row['order_id'].'" find_date="'.$row['date_added'].'" find_zakaz_id="'.$row['order_id'].'" find_zakaz_amount="'.$row['total'].'" find_shipping_fee="'.$row['shipping_fee'].'" find_user_name="'.$row['name'].'" find_surplus="0" find_discount="'.$row['discount'].'"'.' find_discount2="'.$row['discount2'].'">'.$row['order_id'].'</user>'.PHP_EOL;
            }
        }
        $result=$this->xml($result,'users');
        return $result;
    }
    
    
    //   
    private function action_scan_good() {
        $result='';
        $search=$this->get('g_index');
        $search=$this->model->escape($search);
        $res=$this->model->query('SELECT p.*,s.price as special_price,s.date_start,s.date_end,d.name FROM `oc_product` AS p
                            LEFT JOIN `oc_product_special` AS s ON (s.product_id=p.product_id AND s.price>0 AND s.price IS NOT NULL AND s.price<p.price)
                            INNER JOIN `oc_product_description` AS d ON (d.product_id=p.product_id)
                            WHERE p.product_id LIKE \'%'.$search.'%\' OR p.sku LIKE \'%'.$search.'%\' OR p.ean LIKE \'%'.$search.'%\' OR p.model LIKE \'%'.$search.'%\'
                            GROUP BY p.product_id
                            ORDER BY p.product_id ASC');
        if ($res) {
            while($row=$this->model->fetch($res)) {
                $row['sale']=0;
                
                if ($row['special_price']) {
                    $dateline=time();
                    $start=strtotime($row['date_start']);
                    $end=strtotime($row['date_end']);
                    if ($start<$dateline && $end>$dateline) {
                        $row['price']=$row['special_price'];
                        $row['sale']=1;
                    }
                }                
                
                $row['name']=$this->safe_string($row['name']);
                $row['price']=$this->format($row['price'],'scan_good');
                $result.='<good id="'.$row['product_id'].'" goods_sale="'.$row['sale'].'" goods_thumb="image/'.$row['image'].'" goods_sn="'.$row['sku'].'" goods_number="'.$row['quantity'].'" shop_price="'.$row['price'].'" barcode="'.$row['ean'].'">'.$row['name'].'</good>';
            }
        }
        $result=$this->xml($result,'goods');
        return $result;
    }
    
        //    base64_decode   scan_good_find_64
    private function action_scan_good_64() {
        $result='';
        $search=base64_decode($this->get('g_index'));
        $search=$this->model->escape($search);
        $res=$this->model->query('SELECT p.*,s.price as special_price,s.date_start,s.date_end,d.name FROM `oc_product` AS p
                            LEFT JOIN `oc_product_special` AS s ON (s.product_id=p.product_id AND s.price>0 AND s.price IS NOT NULL AND s.price<p.price)
                            INNER JOIN `oc_product_description` AS d ON (d.product_id=p.product_id)
                            WHERE p.product_id LIKE \'%'.$search.'%\' OR p.sku LIKE \'%'.$search.'%\' OR p.ean LIKE \'%'.$search.'%\' OR p.model LIKE \'%'.$search.'%\'
                            GROUP BY p.product_id
                            ORDER BY p.product_id ASC LIMIT 1');
        if ($res) {
            while($row=$this->model->fetch($res)) {
                $row['sale']=0;
                
                if ($row['special_price']) {
                    $dateline=time();
                    $start=strtotime($row['date_start']);
                    $end=strtotime($row['date_end']);
                    if ($start<$dateline && $end>$dateline) {
                        $row['price']=$row['special_price'];
                        $row['sale']=1;
                    }
                }                
                
                $row['name']=$this->safe_string($row['name']);
                $row['price']=$this->format($row['price'],'scan_good');
                $result.='<good id="'.$row['product_id'].'" goods_sale="'.$row['sale'].'" goods_thumb="image/'.$row['image'].'" goods_sn="'.$row['sku'].'" goods_number="'.$row['quantity'].'" shop_price="'.$row['price'].'" barcode="'.$row['ean'].'">'.$row['name'].'</good>';
            }
        }
        $result=$this->xml($result,'goods');
        return $result;
    }
    
            //    base64_decode   
    private function action_scan_good_find_64() {
        $result='';
        $search=base64_decode($this->get('g_index'));
        $search=$this->model->escape($search);
        $res=$this->model->query('SELECT p.*,s.price as special_price,s.date_start,s.date_end,d.name FROM `oc_product` AS p
                            LEFT JOIN `oc_product_special` AS s ON (s.product_id=p.product_id AND s.price>0 AND s.price IS NOT NULL AND s.price<p.price)
                            INNER JOIN `oc_product_description` AS d ON (d.product_id=p.product_id)
                            WHERE p.product_id LIKE \'%'.$search.'%\' OR p.sku LIKE \'%'.$search.'%\' OR p.ean LIKE \'%'.$search.'%\' OR p.model LIKE \'%'.$search.'%\'
                            GROUP BY p.product_id
                            ORDER BY p.product_id ASC');
        if ($res) {
            while($row=$this->model->fetch($res)) {
                $row['sale']=0;
                
                if ($row['special_price']) {
                    $dateline=time();
                    $start=strtotime($row['date_start']);
                    $end=strtotime($row['date_end']);
                    if ($start<$dateline && $end>$dateline) {
                        $row['price']=$row['special_price'];
                        $row['sale']=1;
                    }
                }                
                
                $row['name']=$this->safe_string($row['name']);
                $row['price']=$this->format($row['price'],'scan_good');
                $result.='<good id="'.$row['product_id'].'" goods_sale="'.$row['sale'].'" goods_thumb="image/'.$row['image'].'" goods_sn="'.$row['sku'].'" goods_number="'.$row['quantity'].'" shop_price="'.$row['price'].'" barcode="'.$row['ean'].'">'.$row['name'].'</good>';
            }
        }
        $result=$this->xml($result,'goods');
        return $result;
    }
    
    private function action_scan_skidka() {
        $id=$this->get('g_index');
        if (!$id) return;
        $id=$this->model->escape($id);
        $one=$this->model->one("SELECT * FROM `oc_customer` AS c WHERE c.barcode=$id LIMIT 0,1");
        if (!isset($one['customer_id'])) return;
        $discount=new discount($this->model,$this->get('order_status_id_update'));
        $discount=$discount->getDiscount($one['customer_id']);
        $result='<user id="'.$one['customer_id'].'" user_id="'.$one['customer_id'].'" user_login="'.$one['firstname'].' '.$one['lastname'].'" user_skidka="'.$discount.'">'.$one['barcode'].'</user>';
        $result=$this->xml($result,'users');
        return $result;
    }
    
    private function action_good() {
        $id=$this->get('g_index');
        if (!$id || !is_numeric($id)) return;
        $id=intval($id);
        $res=$this->model->query("SELECT p.*,d.name FROM `oc_product` AS p
                                        INNER JOIN `oc_product_description` AS d ON (d.product_id=d.product_id)
                                        WHERE p.product_id=$id LIMIT 0,1");
        if ($res) {
            while($row=$this->model->fetch($res)) {
                $row['name']=$this->safe_string($row['name']);
                $row['price']=$this->format($row['price'],'good');
                $result.=PHP_TAB.'<good id="'.$row['product_id'].'" goods_thumb="image/'.$row['image'].'" goods_sn="'.$row['sku'].'" goods_number="'.$row['quantity'].'" shop_price="'.$row['price'].'">'.$row['name'].'</good>'.PHP_EOL;
            }
        }
        $result=$this->xml($result,'goods');
        return $result;
    }
    
    private function action_order_back() {
        
    }
    
    private function action_order2() {
        $id=$this->get('g_index');
        if (!$id) return;
        $this->model->query("UPDATE `oc_order` SET `order_status_id`={$this->get('order_status_id_update')} WHERE `order_id`=$id");
        echo $id;
    }
    
    private function action_order() {
        $xml=isset($_POST['input_xml']) ? stripslashes($_POST['input_xml']) : false;
        $xml=simplexml_load_string($xml);
        $kassa=isset($_GET['kassa']) ? base64_decode($_GET['kassa']) : false;
        //$tema2=isset($_GET['tema2']) ? base64_decode($_GET['tema2']) : false;
        $tema2=isset($_GET['tema2']) ? base64_decode(str_replace(' ','+',$_GET['tema2'])) : false; //775 04062019
    
    //PHP_VERSION  7
    if (!is_object($xml) && !$kassa && !$tema2) return;  //php >=7
    //if (!is_object($xml) && !$kassa && !$tema2) continue;
        $kassa=$kassa ? $kassa : 'k1';
        $discount=$this->get('discount') ? $this->get('discount') : '0.00';
        $kassir=$tema2 ? $tema2 : '';
        $user_id=$this->get('user_id')>0 ? $this->get('user_id') : 0;
        $dateline=@date('Y-m-d H:i:s');
        $fio=explode(' ',$kassir);
        $fio[1]=isset($fio[1]) ? $fio[1] : false;
        if (!count($xml->good)) return;
        $total=0;
        
        foreach($xml->good as $item) {
            $total+=(float)$item->total_price;
        }
        
      $sql1="INSERT INTO `oc_order` SET
            `order_id`='0',
            `invoice_no`='0',
            `invoice_prefix`='{$this->get('invoice_prefix')}',
            `store_id`='0',
            `store_name`='$kassa',
            `store_url`='{$this->get('store_url')}',
            `customer_id`='$user_id',
            `customer_group_id`='1',
            `firstname`='$fio[1]',
            `lastname`='$fio[0]',
            `email`='{$this->get('email')}',
            `telephone`='{$this->get('telephone')}',
            `fax`='',
            `payment_firstname`='$fio[1]',
            `payment_lastname`='$fio[0]',
            `payment_company`='{$this->get('company')}',
            `payment_address_1`='{$this->get('address')}',
            `payment_address_2`='',
            `payment_city`='{$this->get('city')}',
            `payment_postcode`='{$this->get('postcode')}',
            `payment_country`='{$this->get('country')}',
            `payment_country_id`='{$this->get('country_id')}',
            `payment_zone`='{$this->get('zone')}',
            `payment_zone_id`='{$this->get('zone_id')}',
            `payment_address_format`='',
            `payment_method`='{$this->get('payment_method')}',
            `payment_code`='{$this->get('payment_code')}',
            `shipping_firstname`='$fio[1]',
            `shipping_lastname`='$fio[0]',
            `shipping_company`='{$this->get('company')}',
            `shipping_address_1`='{$this->get('address')}',
            `shipping_address_2`='',
            `shipping_city`='{$this->get('city')}',
            `shipping_postcode`='{$this->get('postcode')}',
            `shipping_country`='{$this->get('country')}',
            `shipping_country_id`='{$this->get('country_id')}',
            `shipping_zone`='{$this->get('zone')}',
            `shipping_zone_id`='{$this->get('zone_id')}',
            `shipping_address_format`='',
            `shipping_method`='{$this->get('shipping_method')}',
            `shipping_code`='{$this->get('shipping_code')}',
            `comment`='',
            `total`='$total',
            `order_status_id`='{$this->get('order_status_id_insert')}',
            `affiliate_id`='0',
            `commission`='0.0000',
            `language_id`='1',
            `currency_id`='1',
            `currency_code`='RUB',
            `currency_value`='1.0',
            `ip`='127.0.0.1',
            `forwarded_ip`='127.0.0.1',
            `user_agent`='PHP',
            `accept_language`='RU',
            `date_added`='$dateline',
            `date_modified`='$dateline'
        ";
        //$this->log1($sql1);
        $this->model->query($sql1);  
        
        /*
        $this->model->query("INSERT INTO oc_order SET
            `order_id`=0,
            `invoice_no`=0,
            `invoice_prefix`='{$this->get('invoice_prefix')}',
            `store_id`=0,
            `store_name`='$kassa',
            `store_url`='{$this->get('store_url')}',
            `customer_id`=$user_id,
            `customer_group_id`=1,
            `firstname`='$fio[1]',
            `lastname`='$fio[0]',
            `email`='{$this->get('email')}',
            `telephone`='{$this->get('telephone')}',
            `fax`='',
            `custom_field`='',
            `payment_firstname`='$fio[1]',
            `payment_lastname`='$fio[0]',
            `payment_company`='{$this->get('company')}',
            `payment_address_1`='{$this->get('address')}',
            `payment_address_2`='',
            `payment_city`='{$this->get('city')}',
            `payment_postcode`='{$this->get('postcode')}',
            `payment_country`='{$this->get('country')}',
            `payment_country_id`={$this->get('country_id')},
            `payment_zone`='{$this->get('zone')}',
            `payment_zone_id`={$this->get('zone_id')},
            `payment_address_format`='',
            `payment_custom_field`='' ,
            `payment_method`='{$this->get('payment_method')}',
            `payment_code`='{$this->get('payment_code')}',
            `shipping_firstname`='$fio[1]',
            `shipping_lastname`='$fio[0]',
            `shipping_company`='{$this->get('company')}',
            `shipping_address_1`='{$this->get('address')}',
            `shipping_address_2`='',
            `shipping_city`='{$this->get('city')}',
            `shipping_postcode`='{$this->get('postcode')}',
            `shipping_country`='{$this->get('country')}',
            `shipping_country_id`={$this->get('country_id')},
            `shipping_zone`='{$this->get('zone')}',
            `shipping_zone_id`={$this->get('zone_id')},
            `shipping_address_format`='',
            `shipping_custom_field`='',
            `shipping_method`='{$this->get('shipping_method')}',
            `shipping_code`='{$this->get('shipping_code')}',
            `comment`='',
            `total`=$total,
            `order_status_id`={$this->get('order_status_id_insert')},
            `affiliate_id`=0,
            `commission`=0.0000,
            `marketing_id`=0,
            `tracking`='',
            `language_id`=1,
            `currency_id`=1,
            `currency_code`='RUB',
            `currency_value`=1.00000000,
            `ip`='127.0.0.1',
            `forwarded_ip`='127.0.0.1',
            `user_agent`='PHP',
            `accept_language`='RU',
            `date_added`='$dateline',
            `date_modified`='$dateline'
        "); */
        $id=$this->model->insert_id();
        if (!$id) return;
        
        foreach($xml->good as $item) {
            $name=$this->convert($item->good_name);
            $sm=$this->convert($item->good_sm);
            
            /*$this->model->query("INSERT INTO oc_order_product SET
                `order_id`=$id,
                `product_id`={$item->id},
                `name`='$name',
                `model`='$name',
                `sku`='$sm',
                `upc`='',
                `ean`='$sm',
                `jan`='',
                `isbn`='',
                `mpn`='',
                `location`='',
                `quantity`={$item->good_num},
                `price`={$item->market_price},
                `discount_amount`=$discount,
                `discount_type`='',
                `total`={$item->total_price},
                `tax`=18.0000,
                `reward`=0               
            "); */
            
            //market_price2 -    
            //market_price -       
            
             $this->model->query("INSERT INTO `oc_order_product` SET
                `order_id`=$id,
                `product_id`={$item->id},
                `name`='$name',
                `model`='".$this->getModel($item->id, $name)."',
                `quantity`={$item->good_num},
                `price`={$item->market_price},
                `total`={$item->total_price},
                `tax`=18.0000,
                `reward`=0               
            ");
            
            $this->model->query("UPDATE `oc_product` SET `quantity`=`quantity`-'{$item->good_num}' WHERE `product_id`='{$item->id}'");
        }
        
        echo $id;
    }
    
    //  . : $this->log1($sql1);
    private function log1($log_txt) {
        $log=@date('Y:m:d H:i:s');
        
        
        $log.=PHP_EOL;
        $log.=$log_txt;
        $fp=fopen(ABSPATH.'/mk/log2.txt','a');
        if ($fp) {
            fwrite($fp,$log);
            fclose($fp);
        }
    }
    
    private function action_barcodetobase() {
        $id=$this->get('g_index');
        $id=intval($id);
        $barcode=isset($_GET['barcode']) ? trim($_GET['barcode']) : false;
        if (!$id || !$barcode) {
            echo 'error';
            return;
        }
        $barcode=$this->model->escape($barcode);
        
        $this->model->query("UPDATE `oc_product` SET `ean`='$barcode' WHERE `product_id`='$id'");
        
        echo 'ok';
    }
    
        private function action_barcodetobase_64() {
        $id=$this->get('g_index');
        $id=intval($id);
        $barcode=isset($_GET['barcode']) ? trim($_GET['barcode']) : false;
        $barcode=base64_decode($barcode);
        
        if (!$id || !$barcode) {
            echo 'error';
            return;
        }
        $barcode=$this->model->escape($barcode);
        
        $this->model->query("UPDATE `oc_product` SET `ean`='$barcode' WHERE `product_id`='$id'");
        
        echo 'ok';
    }
    
    private function action_barcodetouser() {
        $id=$this->get('g_index');
        $id=intval($id);
        $barcode=isset($_GET['barcode']) ? trim($_GET['barcode']) : false;
        if (!$id || !$barcode) {
            echo 'error';
            return;
        }
        $barcode=$this->model->escape($barcode);
        
        $this->model->query("UPDATE `oc_customer` SET `barcode`='$barcode' WHERE `customer_id`='$id'");
        
        echo 'ok';
    }
    
    
    
     private function getOrderTotal($id) {
        $one=$this->model->one("SELECT * FROM `oc_order_total` AS t WHERE t.order_id='$id' AND t.code='sub_total' AND t.value>0 LIMIT 0,1");
        if (!isset($one['order_id'])) return;
        $sub_total=$this->format($one['value'],'sub_total');
        $result=$sub_total;
        return $result;
    }
    
    private function getOrderShipping($id) {
        $one=$this->model->one("SELECT * FROM `oc_order_total` AS t WHERE t.order_id=$id AND t.code='shipping' AND t.value>0 LIMIT 0,1");
        if (!isset($one['order_id'])) return;
        $result=array(
            'name'=>'',
            'cost'=>$this->format($one['value'],'shipping')
        );
        return $result;
    }
    
    private function getOrderDiscount_old($id,$mode=1) {
        if ($mode==1) {
            $one=$this->model->one("SELECT * FROM `oc_order_total` AS t WHERE t.order_id='$id' AND t.code='coupon' LIMIT 0,1");
            if (!isset($one['order_id'])) return;
            $result=$one['value'];
            $result=trim($result,'-');
            $result=$this->format($result,'discount');
            if (isset($result)){
                return $result;	
            } else {
                $result=0;
                return $result;
            }
        } elseif ($mode==2) {
            $result=0;
            $res=$this->model->query("SELECT * FROM `oc_order_total` AS t WHERE t.order_id='$id' AND (t.code='coupon' OR t.code='discount') ORDER BY t.order_total_id ASC");
            if ($res) {
                while($row=$this->model->fetch($res)) {
                    $result+=$row['value'];
                }
            }
            return $result;
        }
    }
    
    private function getUserPointsByOrder_old($id) {
        $result=0;
        $one=$this->model->one('SELECT o.customer_id FROM `oc_order` AS o WHERE o.order_id='.$id.' LIMIT 0,1');
        $customer_id=isset($one['customer_id']) ? $one['customer_id'] : false;
        if (!$customer_id) $result;        
        $one=$this->model->one("SELECT SUM(points) AS total FROM `oc_customer_reward` WHERE customer_id = '" . $customer_id . "'");
        $result=isset($one['total']) ? $one['total'] : 0;
        return $result;
    }
    
        
    
    //     
    private function getOrderDiscount($id,$mode=1) {
        if ($mode==1) {
            $one=$this->model->one("SELECT * FROM `oc_order_total` AS t WHERE t.order_id='$id' AND t.code='coupon' LIMIT 0,1");
            if (!isset($one['order_id'])) return;
            $result=$one['value'];
            $result=trim($result,'-');
            $result=$this->format($result,'discount');
            if (isset($result)){
                return $result;	
            } else {
                $result=0;
                return $result;
            }
        } elseif ($mode==2) {
            $result=0;
            $res=$this->model->query("SELECT * FROM `oc_order_total` AS t WHERE t.order_id='$id' AND (t.code='coupon' OR t.code='discount') ORDER BY t.order_total_id ASC");
            if ($res) {
                while($row=$this->model->fetch($res)) {
                    $result+=$row['value'];
                }
            }
            return $result;
        }
       }    
        
        
        //    
        private function getUserPointsByOrder($id) {
        $result=0;
        $one=$this->model->one('SELECT o.customer_id FROM `oc_order` AS o WHERE o.order_id='.$id.' LIMIT 0,1');
        $customer_id=isset($one['customer_id']) ? $one['customer_id'] : false;
        if (!$customer_id) $result;        
        $one=$this->model->one("SELECT SUM(points) AS total FROM `oc_customer_reward` WHERE customer_id = '" . $customer_id . "'");
        $result=isset($one['total']) ? $one['total'] : 0;
        return $result;
        //return $customer_id;
        
    }
    
    private function action_zakaz() {
        $result='';
        $res=$this->model->query('SELECT * FROM `oc_order_product` AS p
                            WHERE p.order_id='.$this->get('g_index').'
                            ORDER BY p.product_id ASC');
        $one=$this->model->one('SELECT COUNT(p.product_id) AS `count` FROM `oc_order_product` AS p
                            WHERE p.order_id='.$this->get('g_index').'
                            ORDER BY p.product_id ASC');
        if ($res) {
            $discount=$this->getOrderDiscount($this->get('g_index'),2)/$one['count'];
            $discount+=$this->getUserPointsByOrder($this->get('g_index'));
            while($row=$this->model->fetch($res)) {
                $row['discount_amount']=isset($row['discount_amount']) ? $row['discount_amount'] : 0;
                if ($discount) {
                    $row['discount_amount']=ceil($discount/$row['quantity']);
                }                
                $row['name']=$this->safe_string($row['name']);
                $row['price']=$this->format($row['price'],'zakaz');
                $row['total']=$this->format($row['total'],'zakaz_total');
                $row['sku']=isset($row['sku']) ? $row['sku'] : false;
                $result.=PHP_TAB.'<user id="'.$row['product_id'].'" goods_name="'.$row['name'].'" goods_sale="0" chena="'.$row['price'].'" goods_sn="'.$row['sku'].'" kolvo="'.$row['quantity'].'" summa_g="'.$row['total'].'" summa_all="'.$row['price'].'" extension_code="goods" discount="'.$row['discount_amount'].'">'.$row['product_id'].'</user>'.PHP_EOL;
            }
        }        
        $result=$this->xml($result,'users');
        return $result;
    }
    
    private function action_ostatki() {
        $id=$this->get('g_index');
        $id=intval($id);
        $ostatki=isset($_GET['ostatki']) && is_numeric($_GET['ostatki']) ? intval($_GET['ostatki']) : false;
        if (!$id) return;
        $this->model->query("UPDATE `oc_product` SET `quantity`=$ostatki WHERE `product_id`='$id'");
        $result='ok';
        return $result;
    }
    
    private function getModel($id, $name = '') {
        $one=$this->model->one("SELECT * FROM `oc_product` WHERE `product_id`='$id' LIMIT 0,1");
        if (!isset($one['model'])) {$result= $name;} else {
     	 $result=$one['model'];}
        return $result;
    }
    
    private function action_fupload() {
        $id=$this->get('g_index');
        $id=intval($id);
        if (!isset($_FILES['file']['tmp_name']) ||  !file_exists($_FILES['file']['tmp_name']) || !$id) return;
        $one=$this->model->one("SELECT * FROM `oc_product` AS p WHERE p.product_id='$id' LIMIT 0,1");
        if (!isset($one['product_id'])) return;
        if (!preg_match('{\.(jpg|jpeg)$}is',$one['image'])) {
            $one['image']=preg_replace('/\.(.*){3,4}$/is','.jpg',$one['image']);
        }
        $one['image']=preg_replace('{\.jpg$}','',$one['image']);
        $one['image']=preg_replace('{_update$}','',$one['image']);
        $one['image'].='_update.jpg';
        
        $name=$id.$one['image'];
        $filename=ABSPATH.'/image/'.$name;
        $data=file_get_contents($_FILES['file']['tmp_name']);
        $img=imagecreatefromstring($data);
        imagejpeg($img,$filename,100);
        imagedestroy($img);
        
        $this->model->query("UPDATE `oc_product` SET `image`='$name' WHERE `product_id`='$id'");
        
        $result='ok';
        return $result;
    }
    
    private function action_bonuscard() {
    	//-------------------------------------------------------------------------------------------------------------
	//-------------------------------------------------------------------------------------------------------------
	try
	{     /* if ($g_index>0)
	        {  $sql="SELECT `type_money` FROM `".$prefix."bonus_type` WHERE send_type='3' and type_id=(SELECT `bonus_type_id` FROM `".$prefix."user_bonus` WHERE bonus_sn='".$g_index."' and user_id='0')";
			   $result2 = $db->getRow($sql);

			   if ($result2)
				{
				echo $result2['type_money'];
				}
					else
				{
				echo 'error';
				}

		     }
		     */
	}
	catch (Exception $exp)
	{
	        echo 'Caught exception GROUPS-> : ', $exp->getMessage(), "\n";
	}
	//--------------------------------------------------------------------------------------------------------
	//test
	$id=$this->get('g_index');
	return $id;
        
    }
    
    private function action_bonuscard_to_use() {
    	//-------------------------------------------------------------------------------------------------------------
	//-------------------------------------------------------------------------------------------------------------
	try
	{      
	$id=$this->get('g_index');
	if ($id>0)
	        {  /*
	           $sql="UPDATE `".$prefix."user_bonus` SET `user_id` = '1' WHERE `".$prefix."user_bonus`.`bonus_sn` ='".$g_index."';";
			   $result2 = $db->getRow($sql);

			   if ($result2)
				{
				echo 'ok';
				}
					else
				{
				echo 'error';
				}
               */
		     }
	}
	catch (Exception $exp)
	{
	        echo 'Caught exception GROUPS-> : ', $exp->getMessage(), "\n";
	}
	//--------------------------------------------------------------------------------------------------------
	//
	return 'ok';
        
    }
    
    private function action_query_NDS() {
    	$id=$this->get('g_index');
        $id=intval($id);
    	//oc_tax_rate
    	//% rate
    	//tax_class_id
    	//id tax_rate_id
    	
    	
    	//   tax_class_id
    	//id-9=10%
    	//id-11=18%
    	//id-12=20%
    	$one=$this->model->one("SELECT * FROM `oc_product` AS p WHERE p.product_id='$id' LIMIT 0,1");
        if (isset($one['tax_class_id'])) {
		      // TaxTypeNumber -  :
		      // 	0 -   
		      // 	1 -  0%
		      // 	2 -  10%
		      // 	3 -  18%
		      // 	4 -   
		      // 	5 -     10%
		      // 	6 -     18%
		      
		      if ($one['tax_class_id']==''){return (4);}
		      if ($one['tax_class_id']==0) {return (4);}
		      //if ($one['tax_class_id']==9) {return (2);}//10%
		      //if ($one['tax_class_id']==11){return (3);}//18% 
		      //if ($one['tax_class_id']==12){return (3);} // 20%  18%     .
		      // if ($one['tax_class_id']==13){return (7);} //20%    
			 
					
		} else 
		{
			
		$result=$this->get('nds');
        return $result.$one['tax_class_id'];	
        
		}
    }

    //
    private function action_findzakaz_yandex() {
        $result='';
        $pay_code=$this->get('pay_code');
        $order_status_id=$this->get('yandex_order_status_id');
        //
        //yd=3 -  , yd=5 -  
        $res=$this->model->query("SELECT * FROM `oc_order` AS o WHERE (o.payment_code='$pay_code' AND o.order_status_id='$order_status_id' AND o.yd!=1) or (o.yd=3) or (o.yd=5) ORDER BY o.order_id ASC");
        if ($res) {
            while($row=$this->model->fetch($res)) {
                $row['name']=$row['firstname'].' '.$row['lastname'];
                $row['total']=$this->format($row['total'],'findzakaz');
                $row['shipping_fee']=0;
                $shipping=$this->getOrderShipping($row['order_id']);
                if ($shipping) {
                    $row['shipping_fee']=$shipping['cost'];
                    $row['total']=$row['total']-$shipping['cost'];
                }
                $row['discount']=0;
                //$discount=$this->getOrderDiscount($row['order_id']);
                //if ($discount) {
                    //$row['discount']=$discount;
                    $row['discount']=($this->getOrderTotal($row['order_id']))-$this->format($row['total'],'findzakaz');//     
                    
                //}
                $row['discount2']=$this->getUserPointsByOrder($row['order_id']);
                
                if (!$row['discount']) {
                    //$discount=new discount($this->model,$this->get('order_status_id_update'));
                    //if (!isset($one)){$one=0;}
                    //$discount=$discount->getDiscount($one['customer_id'],0);
                    //$row['discount']=$discount;
                }
                
                $result.=PHP_TAB.'<user id="'.$row['order_id'].'" find_date="'.$row['date_added'].'" find_zakaz_id="'.$row['order_id'].'" find_zakaz_amount="'.$row['total'].'" find_shipping_fee="'.$row['shipping_fee'].'" find_email="'.$row['email'].'" find_user_name="'.$row['name'].'" find_surplus="0" find_discount="'.$row['discount'].'"  yd="'.$row['yd'].'">'.$row['order_id'].'</user>'.PHP_EOL;                
            }
        }
        
        if (!$result) {
            //$result.=PHP_TAB.'<user id="" find_date="" find_zakaz_id=" " find_zakaz_amount="" find_shipping_fee="" find_email="" find_user_name="" find_surplus="" find_discount=""></user>'.PHP_EOL;
        }
        
        $result=$this->xml($result,'users');
        return $result;
    }
    
	private function action_findzakaz_yandex_test() {
	        $result='';
	        $id=$this->get('g_index');
	        $id=intval($id);
	        
	        $res=$this->model->query("SELECT * FROM `oc_order` AS o WHERE `order_id`='$id' Limit 1");
	        if ($res) {
	            while($row=$this->model->fetch($res)) {
	                $result.=PHP_TAB.'<order order_status_id="'.$row['order_status_id'].'" payment_code="'.$row['payment_code'].'" yd="'.$row['yd'].'">'.$row['order_id'].'</order>'.PHP_EOL;                
	            }
	        }
	        
	        if (!$result) {
	        }
	        
	        $result=$this->xml($result,'orders');
	        return $result;
	    }
    
    private function action_close_findzakaz_yandex() {
        $id=$this->get('g_index');
        $id=intval($id);
        if (!$id) return;
        $this->model->query("UPDATE `oc_order` SET `yd`=1 WHERE `order_id`='$id'");
        $result='ok';
        return $result;
    }
    
    private function action_install() {
        $one=$this->model->one("SHOW COLUMNS FROM `oc_order` WHERE FIELD='yd'");
        if (!isset($one['Field'])) {
            $this->model->query("ALTER TABLE `oc_order` ADD COLUMN yd VARCHAR(255) DEFAULT '0'");
            $this->model->query("UPDATE `oc_order` SET `yd`=1");
        }
        
        $one=$this->model->one("SHOW COLUMNS FROM `oc_customer` WHERE FIELD='barcode'");
        if (!isset($one['Field'])) {
            $this->model->query("ALTER TABLE `oc_customer` ADD COLUMN barcode VARCHAR(255) DEFAULT ''");
        }        
        
        $one=$this->model->one("SHOW COLUMNS FROM `oc_category` WHERE FIELD='category_id2'");
        if (!isset($one['Field'])) {
            $this->model->query("ALTER TABLE `oc_category` ADD COLUMN category_id2 INT DEFAULT '0'");
            $this->model->query("ALTER TABLE `oc_category` ADD COLUMN parent_id2 INT DEFAULT '0'");
            $this->model->query("ALTER TABLE `oc_category` ADD COLUMN YML_loader_id INT DEFAULT '0'");
        }
        
        
    }
    
    /*    add_tree */
    private function action_tree_rebild() {
    	$YML_loader_id=1;
    	$res=$this->model->query("SELECT * FROM `oc_category` WHERE `YML_loader_id`='$YML_loader_id' ORDER BY `category_id` ASC");
        if ($res) {
         while($row=$this->model->fetch($res)) {
            $category_id = $row['category_id'];
            $category_id2= $row['category_id2'];
            $parent_id2  = $row['parent_id2'];    
            /*   */
		        //,             
		        if ($parent_id2>0){
				    $one=$this->model->one("SELECT c.category_id FROM `oc_category` AS c WHERE c.category_id2='$parent_id2' AND `YML_loader_id`='$YML_loader_id' LIMIT 0,1");
					$one1=$one['category_id'];
					if($one1>0){$this->model->query("UPDATE `oc_category` SET `parent_id`='$one1' WHERE `category_id`='$category_id' AND `YML_loader_id`='$YML_loader_id'");
					}
					
				}
                   
            }        
        }
    	}
    
    private function action_add_tree() {
        	
        $xml=isset($_POST['input_xml']) ? stripslashes($_POST['input_xml']) : false;
        $xml=simplexml_load_string($xml);
        $dateline=@date('Y-m-d H:i:s');
        if (!count($xml->point)) return;
        
        foreach($xml->point as $item) {
        $tree_name=base64_decode(str_replace(' ','+',$item->tree_name));
		$tree_name=str_replace("'",'`',$tree_name);
		$tree_name=str_replace("&",' ',$tree_name);
        $category_id2=($item->category_id2);
        $parent_id2=($item->parent_id2);
        $YML_loader_id=($item->YML_loader_id);
        
        }
        
      $sql1="INSERT INTO `oc_category` SET
            
           `category_id2`='$category_id2',
           `parent_id2`='$parent_id2',
           `YML_loader_id`='$YML_loader_id',
           `status`='1'
        ";
        //$this->log1($sql1);
        $this->model->query($sql1);  
        $id=$this->model->insert_id();
        if (!$id) return;
        
        
			
		/*
        //,             
        if ($parent_id2>0){
		    $one=$this->model->one("SELECT c.category_id FROM `oc_category` AS c WHERE c.category_id2='$parent_id2' AND `YML_loader_id`='$YML_loader_id' LIMIT 0,1");
			
			$this->log1('one-'.$one.' ID:'.$id.' parent_id2:'.$parent_id2);
			$this->log1("SELECT c.category_id FROM `oc_category` AS c WHERE c.category_id2='$parent_id2' AND `YML_loader_id`='$YML_loader_id' LIMIT 0,1");
			if($one>0){$this->model->query("UPDATE `oc_category` SET `parent_id`='$one' WHERE `category_id`='$id'");}
		}
        
        */
        
        
        
        //oc_category_description
        $this->model->query("INSERT INTO `oc_category_description` SET
                `category_id`='$id',
                `language_id`=1,
                `name`='$tree_name',
                `description`=''
               
            ");
            
        //`oc_category_to_store`    	
        $this->model->query("INSERT INTO `oc_category_to_store` SET
                `category_id`='$id',
                `store_id`='0'
               
            ");
            
        //oc_category_to_layout
                $this->model->query("INSERT INTO `oc_category_to_layout` SET
                `category_id`='$id',
                `store_id`='0',
                `layout_id`='0'
               
            ");
        
        
            
        $result=$cat_id;
        return $result;
    }
    
        
    /*    add_goods */
    
        private function action_add_goods() {
        $xml=isset($_POST['input_xml']) ? stripslashes($_POST['input_xml']) : false;
        $xml=simplexml_load_string($xml);
        $dateline=@date('Y-m-d H:i:s');
        if (!count($xml->point)) return;
        
        foreach($xml->point as $item) {
        $name=base64_decode(str_replace(' ','+',$item->goods_name));
		$goods_name=str_replace("'",'`',$name);
		$goods_name=str_replace("&",' ',$goods_name);
        $goods_number=($item->number);
        $barcode=($item->barcode);
        $articul=base64_decode(str_replace(' ','+',$item->goods_sn));//($item->goods_sn);
        $suppliers_id=($item->suppliers_id);
        $cat_id=($item->cat_id);    
        $brand_id=($item->brand_id);
        $is_post=($item->is_post);
        if ($is_post==''){$is_post='1';}
        $available=($item->available);
        
	    $z_price=($item->z_price);
	    $shop_price=($item->z_price2);// 

	    $goods_brief=base64_decode(str_replace(' ','+',$item->goods_brief));
		$goods_brief=str_replace("'",'`',$goods_brief);
		$old_shop_price=($shop_price/0.80);
               
            
        }
        
      $sql1="INSERT INTO `oc_product` SET
            
           `model`='$articul',
           `status`='1',
           `ean`='$barcode',
           `manufacturer_id`='$brand_id',
           `quantity`='$goods_number',
           `price`='$shop_price',
           `date_available`='$dateline',
           `date_added`='$dateline',
           `date_modified`='$dateline'
           
            
            
        ";
     

       //
        $this->model->query($sql1);  
        $id=$this->model->insert_id();
        if (!$id) return;
        
        
        
        //oc_product_description
        $this->model->query("INSERT INTO `oc_product_description` SET
                `product_id`='$id',
                `language_id`=1,
                `name`='$goods_name',
                `description`='$goods_brief'
               
            ");	
        //`oc_product_to_store` 
        $this->model->query("INSERT INTO `oc_product_to_store` SET
                `product_id`='$id',
                `store_id`=0
            ");
        
        //oc_product_to_category
        $one=$this->model->one("SELECT c.category_id FROM `oc_category` AS c WHERE c.category_id2='$cat_id' AND `YML_loader_id`='1' LIMIT 0,1");
        $cat_id=$one['category_id'];
         $this->log1($cat_id.'  '."INSERT INTO `oc_product_to_category` SET
                `product_id`='$id',
                `category_id`='$cat_id'
            ");
        $this->model->query("INSERT INTO `oc_product_to_category` SET
                `product_id`='$id',
                `category_id`='$cat_id'
            ");
        
        
        	
        //$id=$this->get('g_index');
        //$id=intval($id);
        //if (!$id) return;
        //$this->model->query("UPDATE oc_order SET `yd`=1 WHERE `order_id`=$id");
        
        
        
        $cat_id=$id;
        $result=$cat_id;
        return $result;
    }
    
    
        private function action_proizvoditel() {
        $result='';
        $res=$this->model->query('SELECT * From `oc_manufacturer` ORDER BY `name` ASC');
        if ($res) {
            while($row=$this->model->fetch($res)) {
                //$row['name']=$this->safe_string($row['name']);
                //$row['price']=$this->format($row['price'],'goods2');
                $result.='<good id="'.$row['manufacturer_id'].'"  is_show="1">'.base64_encode($row["name"]).'</good>'.PHP_EOL;
            }
        }
        $result=$this->xml($result,'goods');
        return $result;
    }
    
//*******************************************************************************
//    
//*******************************************************************************

private function action_convert()
 {          $currency_default ='USD';
            $currency_code ='RUB';
            $ymlcontent = "<?xml version=\"1.0\" encoding=\"windows-1251\"?>\n";
        $ymlcontent .= "<convert>\n";



            //***********************
            // www.cbr.ru     *******
            //***********************
            //***********************
                $ymlcontent .= "<cbr ";
				#  URL   cbr.ru
				$scripturl = 'http://www.cbr.ru/scripts/XML_dynamic.asp';

				#      ( - 2 )
				$date_1=date('d/m/Y', time()-172800);

				#   (     time()+86400)
				$date_2=date('d/m/Y');

				#  ,      2,   3  .
				#  2 -   ""    ,  -  3

				#      cbr.ru
				$currency_code='R01235';

				# URL   
				$requrl = "{$scripturl}?date_req1={$date_1}&date_req2={$date_2}&VAL_NM_RQ={$currency_code}";

				$doc = file($requrl);
				$doc = implode($doc, '');

				#  
				$r = array();

				#  <ValCurs>...</ValCurs>
				if(preg_match("/<ValCurs.*?>(.*?)<\/ValCurs>/is", $doc, $m))
					#      <Record>...</Record>
					preg_match_all("/<Record(.*?)>(.*?)<\/Record>/is", $m[1], $r, PREG_SET_ORDER);

				$m = array();	#   , 
				$d = array();	#   

				#      
				for($i=0; $i<count($r); $i++) {
					if(preg_match("/Date=\"(\d{2})\.(\d{2})\.(\d{4})\"/is", $r[$i][1],$m)) {
						$dv = "{$m[1]}/{$m[2]}/{$m[3]}"; #    . 
						if(preg_match("/<Nominal>(.*?)<\/Nominal>.*?<Value>(.*?)<\/Value>/is", $r[$i][2], $m)) {
							$m[2] = preg_replace("/,/",".",$m[2]);
							$d[] = array($dv, $m[1], $m[2]);
							}
						}
					}

				$last = array_pop($d);				#   
				$prev = array_pop($d);				# .  
				$date = $last[0];				#  
				$rate = sprintf("%.2f",$last[2]);		#  
				#   , , "+0.02"
				$delta = (($last[2]>$prev[2])?"+":"").sprintf("%.2f",$last[2]-$prev[2]);
				#echo("{$date}: 1USD={$rate}RUR ({$delta})<BR>");
                $ymlcontent .= 'USD="'.$rate.'" ';
                //$ymlcontent .= "</cbr>\n";


                /*
				 *
				 * EURO
				 *
				 */

				  //$ymlcontent .= "<EUR>";
				#  URL   cbr.ru
				$scripturl = 'http://www.cbr.ru/scripts/XML_dynamic.asp';

				#      ( - 2 )
				$date_1=date('d/m/Y', time()-172800);

				#   (     time()+86400)
				$date_2=date('d/m/Y');

				#  ,      2,   3  .
				#  2 -   ""    ,  -  3

				#      cbr.ru R01239 http://www.cbr.ru/scripts/XML_val.asp?d=0
				$currency_code='R01239';

				# URL   
				$requrl = "{$scripturl}?date_req1={$date_1}&date_req2={$date_2}&VAL_NM_RQ={$currency_code}";

				$doc = file($requrl);
				$doc = implode($doc, '');

				#  
				$r = array();

				#  <ValCurs>...</ValCurs>
				if(preg_match("/<ValCurs.*?>(.*?)<\/ValCurs>/is", $doc, $m))
					#      <Record>...</Record>
					preg_match_all("/<Record(.*?)>(.*?)<\/Record>/is", $m[1], $r, PREG_SET_ORDER);

				$m = array();	#   , 
				$d = array();	#   

				#      
				for($i=0; $i<count($r); $i++) {
					if(preg_match("/Date=\"(\d{2})\.(\d{2})\.(\d{4})\"/is", $r[$i][1],$m)) {
						$dv = "{$m[1]}/{$m[2]}/{$m[3]}"; #    . 
						if(preg_match("/<Nominal>(.*?)<\/Nominal>.*?<Value>(.*?)<\/Value>/is", $r[$i][2], $m)) {
							$m[2] = preg_replace("/,/",".",$m[2]);
							$d[] = array($dv, $m[1], $m[2]);
							}
						}
					}

				$last = array_pop($d);				#   
				$prev = array_pop($d);				# .  
				$date = $last[0];				#  
				$rate = sprintf("%.2f",$last[2]);		#  
				#   , , "+0.02"
				$delta = (($last[2]>$prev[2])?"+":"").sprintf("%.2f",$last[2]-$prev[2]);
				#echo("{$date}: 1USD={$rate}RUR ({$delta})<BR>");
                $ymlcontent .='EUR="'.$rate.'" ';
                $ymlcontent .= "></cbr>";
                $ymlcontent .= "\n</convert>\n";
		echo $ymlcontent;
 }    
    
    
}

mk7877::init();
?>